clc;clear;close all;

pos = [-1 -1;0 -1;1 -1;-1 0;1 0;-1 1;0 1;1 1];
neg = [-0.5 0;0.5 0;0 0.5];

figure('Name','Data')
plot(pos(:,1),pos(:,2),'b+',neg(:,1),neg(:,2),'rx');

input=[pos;neg];
target=[ones(length(pos),1);(ones(length(neg),1)-2)];

[w_hid, w_out, output, hidden, err_curve] = bp(input, target, 4, 0.05, 10000);

dat=[];
for i=-1:0.05:1
    for j= -1:0.05:1
        dat=[dat;i j];
    end
end

[w_hid2,w_out2, output2, hidden2, err_curve2] = bp(dat, target, 4, 0.1, 1, w_hid,w_out);

opos = find(output2>0);
oneg = find(output2<=0);
figure('Name','Decision Boundary')
plot(dat(opos,1),dat(opos,2),'rx',dat(oneg,1),dat(oneg,2),'b+');
plot(dat(opos,1),dat(opos,2),'rx',dat(oneg,1),dat(oneg,2),'b+',neg(:,1),neg(:,2),'g*',pos(:,1),pos(:,2),'b*');